// @flow
import 'whatwg-fetch';
import _ from 'lodash';
import type {TSourceItem} from '../flow-typed';
import {default as entities} from '../entities';
import {default as settings} from '../settings';
import {rest} from '../';

export default (params: {
	baseURL: settings.baseURL,
	entity?: string,
	key: string,
	sources?: Array<TSourceItem>
}) => {
	const

		// key is not unqiue across all sources
		entity = params.entity || _.get(_.find(params.sources, {key: params.key}), 'entity'),

		entityExists = _.includes(_.keys(entities(params.baseURL)), entity);

	// entity is necessary for flow success typecheck
	if(!(entity && entityExists))
		return console.error(entityExists
			? `Using non-existent entity '${entity}'`
			: `Using non-existent key '${params.key}'`
		);

	return rest({
		baseURL: params.baseURL,
		entity : entity,
		key    : params.key,
	}).actions[params.key];
};
